/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */

package org.diacalc.mobile.components;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */

import java.util.*;
import org.diacalc.mobile.maths.Str;

public class DateValidator  implements MaskValidator {
    private final static int [] daysinmonth = {31,28,31,30,31,30,31,31,30,31,30,31};
    private final static String numb = "1234567890";

    public Object parse(MaskTextField fld){
        String s = fld.getText();
        //Удаляем все "левые" символы
        String st1="";
        //удаляем все неиспользуемые символы
        for(int i=0;i<s.length();i++){
            for(int j=0;j<numb.length();j++){
                if (s.charAt(i)==numb.charAt(j)){
                    st1 += s.charAt(i);
                    break;
                }
            }
        }
        s = st1;
        if (s.length()<5) return new Date();//Недостаточно символов
        if (s.length()>6) s = s.substring(0, 6);
        //Считаем, что только цифры могут быть ##.##.##
        String day = s.substring(0, 2);
        String month = s.substring(2,4);
        int y = Integer.parseInt(s.substring(4));//год должен быть правильным
        int m = Integer.parseInt(month);
        if (m<1) m = 1;
        else if (m>12) m = 12;
        int d = Integer.parseInt(day);
        
        if (d<1) d =  1;
        else{
            if (m==2){//Февраль
                if (y%4 == 0){//високосный
                    if (d>29) d=29;
                }else{//простой
                    if (d>28) d=28;
                }
            }
            else{
                if (d>daysinmonth[m-1]) d= daysinmonth[m-1];
            }
        }

        fld.setText(Str.extendZero(d)+"."+Str.extendZero(m)+"."+Str.extendZero(y));

        Calendar c = Calendar.getInstance();
        c.set(Calendar.YEAR, y+2000);
        c.set(Calendar.MONTH, m-1);
        c.set(Calendar.DAY_OF_MONTH, d);
        c.set(Calendar.HOUR_OF_DAY, 0);
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.MILLISECOND, 0);

        return c.getTime();
    }
    public String getStringValue(MaskTextField fld,Object o){
        Calendar c = Calendar.getInstance();
        c.setTime((Date)o);

        int d = c.get(Calendar.DAY_OF_MONTH);
        int m = c.get(Calendar.MONTH)+1;
        int y = c.get(Calendar.YEAR) % 100;

        return Str.extendZero(d)+"."+Str.extendZero(m)+"."+Str.extendZero(y);
    }

}
