/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */
package org.diacalc.mobile.components;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */

import org.diacalc.mobile.maths.Str;

public class FloatValidator implements MaskValidator{
    public Object parse(MaskTextField fld){
        int p = fld.getMask().indexOf(".");
        int z = fld.getMask().length() - p - 1;
        //Тут нужно вставить точку, т.к. это float, то она должна быть обязательно.
        String s = fld.getText();
        if (s.indexOf(".")>=0 && s.indexOf(".")!=p){//точка не там, где нужно, удаляем ее совсем
            int p2 = s.indexOf(".");
            s = s.substring(0, p2) + "." + s.substring(p2);
        }
        if (s.indexOf(".")<0){//нет точки
            //Добавляем точку
            s = s.substring(0, p) + "." + s.substring(p);
            if (s.length()>fld.getMask().length())
                s = s.substring(0, fld.getMask().length());
            fld.setText(s);
        }
        return new Float(Str.parseString(fld, z));
    }
    public String getStringValue(MaskTextField fld,Object o){
        int p = fld.getMask().indexOf(".");
        int z = fld.getMask().length() - p - 1;

        return ""+Str.round( ((Float)o).floatValue(),z );
        /*switch(z){
            case 1: return ""+Str.round0( ((Float)o).floatValue() );
            case 2: return ""+Str.round00( ((Float)o).floatValue() );
        }
        
        return ((Float)o).toString();*/
    }
}
