/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */


package org.diacalc.mobile.maths;

/**
 *
 * @author Dancer <http://forum.vingrad.ru/topic-107504.html#>
 */

import java.util.Vector;
import org.diacalc.mobile.products.*;

public class Ordering {
    public static final String [] arrayOfSortingField = {
        "Name",
        "Usage"
    };
    public static final String[] arrayOfSortingType = {
        "ASC",
        "DESC"
    };
    public static final int AVALIABLE_FIELD = 0;
    public static final int NAME_FIELD = 1;
    public static final int USAGE_FIELD = 2;
    public static final int TIME_FIELD = 3;

    //public static final int BITRATE_FIELD = 4;
    public static final int SORT_BY_ASC =0;
    public static final int SORT_BY_DESC =1;
    private static int currentSortField = AVALIABLE_FIELD;
    private static int currentSortType = SORT_BY_DESC;

    public static int getSortField() {
        return currentSortField;
    }
    public static int getSortType() {
        return currentSortType;
    }

    private static void quickSortForStringField(Vector results, int lo0, int hi0) { //throws Exception {
        int lo = lo0;
        int hi = hi0;
        String mid;
        if ( hi0 > lo0) {
        /* Arbitrarily establishing partition element as the midpoint of
         * the array.
        */
            mid = ((ProductW)results.elementAt(( lo0 + hi0 ) / 2 )).getName();
         // loop through the array until indices cross
            while( lo <= hi ) {
            /* find the first element that is greater than or equal to
             * the partition element starting from the left Index.
             */
//                while( ( lo < hi0 ) && ( ((SearchResult)results.elementAt(lo)).getFieldValue(getSortField()).compareTo(mid) < 0 ))
                while( ( lo < hi0 ) && ( compareStrings(((ProductW)results.elementAt(lo)).getName(), mid) < 0 ))
                    ++lo;
            /* find an element that is smaller than or equal to
             * the partition element starting from the right Index.
             */
//                while( ( hi > lo0 ) && ( ((SearchResult)results.elementAt(hi)).getFieldValue(getSortField()).compareTo(mid) > 0))
                while( ( lo < hi0 ) && ( compareStrings(((ProductW)results.elementAt(hi)).getName(), mid) > 0 ))
                    --hi;
            // if the indexes have not crossed, swap
                if( lo <= hi ) {
                    swap(results, lo, hi);
                    ++lo;
                    --hi;
                }
            }
         /* If the right index has not reached the left side of array
          * must now sort the left partition.
          */
            if( lo0 < hi )
                quickSortForStringField(results, lo0, hi );
         /* If the left index has not reached the right side of array
          * must now sort the right partition.
          */
            if( lo < hi0 )
                quickSortForStringField(results, lo, hi0 );
        }
    }
    private static void quickSortForIntegerField(Vector results, int lo0, int hi0) { //throws Exception {
        int lo = lo0;
        int hi = hi0;
        int mid;
        if ( hi0 > lo0) {
            mid = ((ProductInBase)results.elementAt(( lo0 + hi0 ) / 2 )).getUsage();
         // loop through the array until indices cross
            while( lo <= hi ) {
                while( ( lo < hi0 ) && ( ((ProductInBase)results.elementAt(lo)).getUsage() < mid ))
                    ++lo;
                while( ( hi > lo0 ) && ( ((ProductInBase)results.elementAt(hi)).getUsage() > mid ))
                    --hi;
            // if the indexes have not crossed, swap
                if( lo <= hi ) {
                    swap(results, lo, hi);
                    ++lo;
                    --hi;
                }
            }
            if( lo0 < hi )
                quickSortForIntegerField(results, lo0, hi );
            if( lo < hi0 )
                quickSortForIntegerField(results, lo, hi0 );
        }
    }
    private static void quickSortForLongField(Vector results, int lo0, int hi0) { //throws Exception {
        int lo = lo0;
        int hi = hi0;
        long mid;
        if ( hi0 > lo0) {
            mid = ((DiaryUnit)results.elementAt(( lo0 + hi0 ) / 2 )).getTime();
         // loop through the array until indices cross
            while( lo <= hi ) {
                while( ( lo < hi0 ) && ( ((DiaryUnit)results.elementAt(lo)).getTime() < mid ))
                    ++lo;
                while( ( hi > lo0 ) && ( ((DiaryUnit)results.elementAt(hi)).getTime() > mid ))
                    --hi;
            // if the indexes have not crossed, swap
                if( lo <= hi ) {
                    swap(results, lo, hi);
                    ++lo;
                    --hi;
                }
            }
            if( lo0 < hi )
                quickSortForLongField(results, lo0, hi );
            if( lo < hi0 )
                quickSortForLongField(results, lo, hi0 );
        }
    }
    private static void swap(Vector results, int i, int j) {
        Object  T;
        T = (Object) results.elementAt(i);
        results.setElementAt(results.elementAt(j),i);
        results.setElementAt(T,j);
    }
    public static void sort(Vector results) { //throws Exception {
        if(currentSortField == NAME_FIELD ){//|| currentSortField == TYPE_FIELD ) {
            quickSortForStringField(results, 0, results.size() - 1);
        } else if (currentSortField == USAGE_FIELD  ){
            if (results.elementAt(0) instanceof ProductInBase)
                quickSortForIntegerField(results, 0, results.size() - 1);
        } else if (currentSortField == TIME_FIELD  ){
            if (results.elementAt(0) instanceof DiaryUnit)
                quickSortForLongField(results, 0, results.size() - 1);
        }
        //SearchManager.wasChangedSearchedFilesList();
        // на это не обращай внимание, я туту просто дёргаю перерисовку листа после пересортировки данных
    }
    public static void setSortField(int index) {
        currentSortField = index;
    }
    public static void setSortType(int index) {
        currentSortType = index;
    }
    private static int compareStrings(String str1, String str2) {
        /*if(str1.toUpperCase().charAt(0) == str2.toUpperCase().charAt(0)) {
//        if(str1.toLowerCase().charAt(0) == str2.toLowerCase().charAt(0)) {
            return str1.compareTo(str2);
        } else {
            return str1.toUpperCase().compareTo(str2.toUpperCase());
//            return str1.toLowerCase().compareTo(str2.toLowerCase());
        }*/
        return str1.compareTo(str2);
    }
}